%Input maximum number of interations,nloop
clear
nloop=10000;
%Input burn-in,nwarmup
nwarmup=2000;
%Input maximum number of segments
nexp_max=3;
 phi_true=zeros(2,1);
  phi_true(1)=0.9;
 phi_true(2)=-0.9;
sd_true(1)=1;
sd_true(2)=1;
e1=normrnd(0,sd_true(1),1,250);
e2=normrnd(0,sd_true(2),1,250);


 x1=filter(1,[1 -phi_true(1)],e1);
 x2=filter(1,[1 -phi_true(2)],e2);
% %  x3=filter(1,[1 -phi_true(3,:)],e3);
% %  x4=filter(1,[1 -phi_true(4,:)],e4);
  x=[x1 x2]';% x3 x4]'; %piecewise AR(2) with one changepoint 
%load('data_sim_piecewise');
%Loading data
%path(path,'/Users/sallywood/Dropbox/paper with sally/Data Sets/')
% load('nino34_1950_2010_data');
%x=data(2,:);
 
 
 xmat=[ones(length(x),1) linspace(1,length(x),length(x))'];
 linfit=inv(xmat'*xmat)*xmat'*x;
 x=x-xmat*linfit;
global options nobs var_inflate nbasis nbeta sigmasqalpha prob_mm1 tmin tau_prior_a tau_prior_b tau_up_limit step_size_max
options = optimset('Display','off','GradObj','on','Hessian','on','MaxIter',10000,...
'MaxFunEvals',10000,'TolFun',0.001,'TolX',0.00001);
nobs=length(x);
tt=linspace(1,nobs,nobs)';
var_inflate=1.0;
nbasis=7;
nbeta=nbasis+1;
sigmasqalpha=100;
tau_prior_a=-1;
tau_prior_b=0;
prob_mm1=0.8;
tmin=40; 
step_size_max=10;
tausq=cell(nexp_max,1);
beta=cell(nexp_max,1);
xi=cell(nexp_max,1);%Cutpoint locations xi_1 is first cutpoint, xi_) is beginning of timeseries
nseg=cell(nexp_max,1);%Number of observations in each segment
log_spec_hat=cell(nexp_max,1);
nfreq_hat=50;
freq_hat=(0:nfreq_hat)'/(2*nfreq_hat);
[nu_mat_hat]=lin_basis_func(freq_hat,nbeta);
for j=1:nexp_max
	tausq{j}=ones(j,nloop+1);
	beta{j}=ones(nbeta,j,nloop+1);
	xi{j}=ones(j,nloop+1);
	nseg{j}=ones(j,nloop+1);
	log_spec_hat{j}=zeros(nfreq_hat+1,j,nloop+1);
end
nexp_curr=nexp_max*ones(nloop+1,1);
nexp_curr(1)=3;
%nexp_curr(1)=unidrnd(nexp_max);
tau_up_limit=10;
for j=1:nexp_curr(1)
	tausq{nexp_curr(1)}(j,1)=rand*tau_up_limit;
end
for j=1:nexp_curr(1)
    if nexp_curr(1)==1
        xi{nexp_curr(1)}(j,1)=nobs;
        nseg{nexp_curr(1)}(j,1)=nobs;
    else
	if j==1
			nposs=nobs-nexp_curr(1)*tmin+1;
			xi{nexp_curr(1)}(j,1)=tmin+unidrnd(nposs)-1;
			nseg{nexp_curr(1)}(j,1)=xi{nexp_curr(1)}(j,1);
		elseif j>1 && j<nexp_curr(1)
			nposs=nobs-xi{nexp_curr(1)}(j-1,1)-tmin*(nexp_curr(1)-j+1)+1;
			xi{nexp_curr(1)}(j,1)=tmin+unidrnd(nposs)+xi{nexp_curr(1)}(j-1,1)-1;
			nseg{nexp_curr(1)}(j,1)=xi{nexp_curr(1)}(j,1)-xi{nexp_curr(1)}(j-1,1);
		else
			xi{nexp_curr(1)}(j,1)=nobs;
			nseg{nexp_curr(1)}(j,1)=xi{nexp_curr(1)}(j,1)-xi{nexp_curr(1)}(j-1,1);	
		end
    end
end
xi_temp=xi{nexp_curr(1)}(:,1);
nseg_temp=nseg{nexp_curr(1)}(:,1);
tau_temp=tausq{nexp_curr(1)}(:,1);
for j=1:nexp_curr(1)
   	[beta_mean beta_var nu_mat y]=postbeta(j,nseg_temp(j),x,xi_temp,tau_temp(j));
	beta{nexp_curr(1)}(:,j,1)=mvnrnd(beta_mean,0.5*(beta_var+beta_var'));
end
epsilon=zeros(nloop,1);

met_rat=zeros(nloop,1);
Rev_Jump=1;
tic
for p=1:nloop
    if(mod(p,100)==0)
        %toc
        p
    end
	if Rev_Jump==1
	%BETWEEN MODEL MOVE
    %Number of available segments
    kk=length(find(nseg{nexp_curr(p)}(:,p)>2*tmin));
	%Deciding on birth or death
    if (kk==0)%Stay where you (if nexp_curr=1) or join segments if there are no available segments to cut
        if nexp_curr(p)==1
            nexp_prop=nexp_curr(p);% Stay where you are
            log_move_prop=0;
            log_move_curr=0;
        else
            nexp_prop=nexp_curr(p)-1;%join segments
            log_move_prop=1;
            if(nexp_prop==1)
              log_move_curr=1;
            else
              log_move_curr=log(0.5);
            end
        end  
    else
		if nexp_curr(p)==1 
			nexp_prop=nexp_curr(p)+1;
			log_move_prop=0;
			if(nexp_prop==nexp_max)
				log_move_curr=0;
			else
				log_move_curr=log(0.5);
			end
		elseif nexp_curr(p)==nexp_max
			nexp_prop=nexp_curr(p)-1;
			log_move_prop=0;
			if(nexp_prop==1)
				log_move_curr=0;
			else
				log_move_curr=log(0.5);
			end
        else
			u=rand;
			if u<0.5
                nexp_prop=nexp_curr(p)+1;
				if nexp_prop==nexp_max 
					log_move_curr=0;	
					log_move_prop=log(0.5);
				else
					log_move_curr=log(0.5);	
					log_move_prop=log(0.5);
				end
				
            else
                nexp_prop=nexp_curr(p)-1;
				if nexp_prop==1 
					log_move_curr=0;	
					log_move_prop=log(0.5);
				else
					log_move_curr=log(0.5);	
					log_move_prop=log(0.5);
                end
            end
        end
    end
	xi_curr_temp=xi{nexp_curr(p)}(:,p);
	beta_curr_temp=beta{nexp_curr(p)}(:,:,p);
	tau_curr_temp=tausq{nexp_curr(p)}(:,p);
	nseg_curr_temp=nseg{nexp_curr(p)}(:,p);
	if nexp_prop<nexp_curr(p)
		%Death
		[met_rat(p),nseg_prop,xi_prop,tau_prop,beta_prop]=death(x,nexp_curr(p),nexp_prop,...
		tau_curr_temp,xi_curr_temp,nseg_curr_temp,beta_curr_temp,log_move_curr,log_move_prop);
    elseif nexp_prop>nexp_curr(p)
		%Birth,
		[met_rat(p),nseg_prop,xi_prop,tau_prop,beta_prop]=birth(x,nexp_curr(p),nexp_prop,...
		tau_curr_temp,xi_curr_temp,nseg_curr_temp,beta_curr_temp,log_move_curr,log_move_prop);
    else
        xi_prop=xi{nexp_curr(p)}(:,p);
        nseg_prop=nseg{nexp_curr(p)}(:,p);
        tau_prop=tausq{nexp_curr(p)}(:,p);
        beta_prop=beta{nexp_curr(p)}(:,:,p);
        met_rat(p)=1;
	end
	u=rand;
	if u<met_rat(p)
		nexp_curr(p+1)=nexp_prop;
		xi{nexp_curr(p+1)}(:,p+1)=xi_prop;
		nseg{nexp_curr(p+1)}(:,p+1)=nseg_prop;
		tausq{nexp_curr(p+1)}(:,p+1)=tau_prop;
		beta{nexp_curr(p+1)}(:,:,p+1)=beta_prop;
	else
		nexp_curr(p+1)=nexp_curr(p);
		xi{nexp_curr(p+1)}(:,p+1)=xi{nexp_curr(p+1)}(:,p);
		nseg{nexp_curr(p+1)}(:,p+1)=nseg{nexp_curr(p+1)}(:,p);
		tausq{nexp_curr(p+1)}(:,p+1)=tausq{nexp_curr(p+1)}(:,p);
		beta{nexp_curr(p+1)}(:,:,p+1)=beta{nexp_curr(p+1)}(:,:,p);
	end
else
	nexp_curr(p+1)=nexp_curr(p);
	xi{nexp_curr(p+1)}(:,p+1)=xi{nexp_curr(p+1)}(:,p);
	nseg{nexp_curr(p+1)}(:,p+1)=nseg{nexp_curr(p+1)}(:,p);
	tausq{nexp_curr(p+1)}(:,p+1)=tausq{nexp_curr(p+1)}(:,p);
	beta{nexp_curr(p+1)}(:,:,p+1)=beta{nexp_curr(p+1)}(:,:,p);
end
	%WITHIN MODEL MOVE
	 %Drawing a new cut point  and beta simultaneously
	 %First draw the size of the move
xi_curr_temp=xi{nexp_curr(p+1)}(:,p+1);
beta_curr_temp=beta{nexp_curr(p+1)}(:,:,p+1);
tau_temp=tausq{nexp_curr(p+1)}(:,p+1);
nseg_curr_temp=nseg{nexp_curr(p+1)}(:,p+1);
[epsilon(p),xi_prop,beta_prop,nseg_new,seg_temp]=within(x,nexp_curr(p+1),xi_curr_temp,beta_curr_temp,nseg_curr_temp,tau_temp);
u=rand;
if (u<epsilon(p)|| p==1) 
	if nexp_curr(p+1)>1
		for j=seg_temp:seg_temp+1
			beta{nexp_curr(p+1)}(:,j,p+1)=beta_prop(:,j);
			xi{nexp_curr(p+1)}(j,p+1)=xi_prop(j);
			nseg{nexp_curr(p+1)}(j,p+1)=nseg_new(j);
		end
	else
		beta{nexp_curr(p+1)}(:,1,p+1)=beta_prop(:,1);
	end
else
	beta{nexp_curr(p+1)}(:,:,p+1)=beta_curr_temp;
	xi{nexp_curr(p+1)}(:,p+1)=xi_curr_temp;
	nseg{nexp_curr(p+1)}(:,p+1)=nseg_curr_temp;
end
 %Drawing tau
for j=1:nexp_curr(p+1)
	tau_a=nbasis/2+tau_prior_a;
    tau_b=sum(beta{nexp_curr(p+1)}(2:nbeta,j,p+1).^2)/2+tau_prior_b;
    u=rand;
    const1=gamcdf(1/tau_up_limit,tau_a,1/tau_b);
    const2=1-u*(1-const1);
    tausq{nexp_curr(p+1)}(j,p+1)=1/gaminv(const2,tau_a,1/tau_b);
end
%Estimating Spectral Density
for j=1:nexp_curr(p+1)
	log_spec_hat{nexp_curr(p+1)}(:,j,p+1)=nu_mat_hat*beta{nexp_curr(p+1)}(:,j,p+1);
end
end
fmean=cell(nexp_max,1);
%Plots of individual Spectra
for j=1:nexp_max
	kk=find(nexp_curr(nwarmup+1:nloop)==j);
	if ~isempty(kk)
		for k=1:j
              figure
              hold
               title(['Log of Spectral Density for the',int2str(k), 'component in a mixture of ',int2str(j)])
               fmean{j}(:,k)=mean(log_spec_hat{j}(:,k,kk+nwarmup),3);
               plot(freq_hat,fmean{j}(:,k))
          end
	end
end
%Plots of Partition Points
for j=1:nexp_max
	kk=find(nexp_curr(nwarmup+1:nloop)==j);
    post_prob_nexp(j)=length(kk)/(nloop-nwarmup);
    if ~isempty(kk) && j>1
        figure
        hold
        title(['Plot of Partition Points for a mixture of ',int2str(j)])
		for k=1:j-1
            plot(xi{j}(k,kk+nwarmup))
        end
        for k=1:j-1
            figure
            hist(xi{j}(k,kk+nwarmup))
        end
    end
%     if j==2
%         c1=min(xi{j}(1,kk+nwarmup));
%         c2=max(xi{j}(1,kk+nwarmup));
%         cut_grid=linspace(c1,c2,c2-c1)';
%         sort_cut=sort(xi{j}(1,kk+nwarmup));
%     [nout xout]=hist(sort_cut,cut_grid);
%     pexp=cumsum(nout./sum(nout));
%     figure
%     plot(xout,pexp)
%     end
end
%Surface Plot
grid=zeros(nfreq_hat+1,nobs);
for p=1:nloop
    if(p>nwarmup)
        xi_curr=xi{nexp_curr(p)}(:,p);
        log_spec_hat_curr=log_spec_hat{nexp_curr(p)}(:,:,p);
        for j=1:nexp_curr(p)
            if(j==1)
               grid(:,1:xi_curr(j))=grid(:,1:xi_curr(j))+repmat(log_spec_hat_curr(:,j),1,xi_curr(j))/(nloop-nwarmup);
            else
               grid(:,xi_curr(j-1)+1:xi_curr(j))=grid(:,xi_curr(j-1)+1:xi_curr(j))+...
                repmat(log_spec_hat_curr(:,j),1,xi_curr(j)-xi_curr(j-1))/(nloop-nwarmup);
            end
        end
    end
end
figure
h=surf(tt,freq_hat,grid);
set(h, 'edgecolor','none')
set(gca,'YDir','reverse')
            

% 	